# Summary
- [Introduction](./README.md)
- [Installation](./installation.md)
    - [Installing a Local Version (ANNIS Kickstarter)](./installation-kickstarter.md)
    - [Installing an ANNIS Server](./installation-server.md)
    - [Migrating from ANNIS 3](./installation-migrate-annis3.md)
- [Using the ANNIS interface](./interface.md)
    - [Search Form](./interface-search-form.md)
    - [Result Window](./interface-result-window.md)
    - [Query Builder](./interface-query-builder.md)
- [ANNIS Query Language (AQL)](./aql.md)
    - [Searching for Word Forms](./aql-word-forms.md)
    - [Searching for Annotations](./aql-annotations.md)
    - [Searching using Regular Expressions](./aql-regex.md)
    - [Searching for Trees](./aql-trees.md)
    - [Searching for Pointing Relations](./aql-pointing.md)
    - [Exporting Results](./aql-export.md)
    - [Frequency Analysis](./aql-frequency.md)
    - [Complete List of Operators](./aql-operators.md)
    - [Differences in Compatibility Mode](./aql-compatibility-mode.md)
- [Configuring Visualizations](./visualizations.md)
    - [List of Visualizations](./visualizations-list.md)
    - [Maximal Context Size, Context Steps and Result Page Sizes](./visualizations-context.md)
    - [Document Browser](./visualizations-documentbrowser.md)
    - [Right-to-Left Visualizations](./visualizations-rtl.md)
- [Importing and Configuring Corpora](./import-and-config.md)
    - [Converting Corpora for ANNIS using Pepper](./import-and-config-convert.md)
    - [Importing Corpora in the relANNIS format](./import-and-config-import.md)
    - [Configuring Settings for a Corpus](./import-and-config-corpus-config.md)
    - [Multiple Instances of the Interface](./import-and-config-instances.md) 
    - [User Configuration](./import-and-config-user.md)
    - [The administration web interface](./import-and-config-admin-web.md)
- [Advanced Topics](./advanced.md)
    - [Error Codes of the administration tools](./advanced-errorcodes.md)
    - [Provide your own login-system](./advanced-custom-login.md)
    - [Links to queries](./advanced-links-to-queries.md)
    - [Embed ANNIS visualizations](./advanced-embed-vis.md)
